﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Space_Invaders
{
    public partial class Form1 : Form
    {
        private const int WM_PAINT = 0x000F;
        private const int WM_ERASEBKGND = 0x0014;
        public const int ENEMY_COUNT = 8 * 4;
        public const int ENEMY_WIDTH = 32;
        public const int ENEMY_HEIGHT = 32;

        public const int PLAYER_WIDTH = 32;
        public const int PLAYER_HEIGHT = 32;
        public const int ROWS = 4;
        public const int COLS = 8;
        public const int ENEMY_OFFSET = 5;
        public const int GAME_OFFSET_Y = 20;
        public const int GAME_OFFSET_X = ENEMY_OFFSET + (ENEMY_WIDTH / 2);
        public enum movestate {left,right,none};
        public movestate MoveState = movestate.none;
        bool bInit = false;
        GameBoard g = null;
        Player p = null;
        ScoreBoard sb = null;

        PlayerMissle pm = null;

        List<Invader> invaders = null;
        Timer t = null;
        //Board b = null;
        public Form1()
        {
            InitializeComponent();
            Invalidate();
            InitializeGame();
        }

        private void InitializeGame()
        {
            int i = 0;
            int irow = 0;
            int icol = 0;
            p = new Player();
            sb = new ScoreBoard();
            
            sb.Score = 0;
            sb.Position.X = 2;
            sb.Position.Y = 2;

            g = new GameBoard();
            g.Position.X = GAME_OFFSET_X;
            g.Position.Y = GAME_OFFSET_Y;
            g.Width = this.ClientRectangle.Width - (2 * GAME_OFFSET_X);
            g.Height = this.ClientRectangle.Height - (2 * GAME_OFFSET_Y);

            p.Width = PLAYER_WIDTH ;
            p.Height = PLAYER_HEIGHT ;
            p.Position.X = ( this.ClientRectangle.Width / 2 ) - ( PLAYER_WIDTH / 2 ) ;
            p.Position.Y = this.ClientRectangle.Height - ( p.Height + GAME_OFFSET_Y) ;
            Invader.invaderclass invclass = Invader.invaderclass.class1 ;
            invaders = new List<Invader>();
            for (i = 0; i < ENEMY_COUNT; i++){
                Vector v = new Vector(1, 0);
                
                switch ( irow ){
                    case 0 :
                        invclass= Invader.invaderclass.class4 ;
                        break ;
                    case 1 :
                        invclass= Invader.invaderclass.class3 ;
                        break ;
                    case 2 :
                        invclass= Invader.invaderclass.class2 ;
                        break ;
                    case 3 :
                        invclass= Invader.invaderclass.class1 ;
                    break ;
                }
                Invader tmp = new Invader(v, invclass);
                tmp.Position.X = GAME_OFFSET_X + ( ENEMY_WIDTH / 2 )+ (icol * (ENEMY_OFFSET + 32));
                tmp.Position.Y = GAME_OFFSET_Y + (irow * (ENEMY_OFFSET + 32));
                tmp.Width = 32;
                tmp.Height = 32;
                invaders.Add(tmp);
                icol++;
                if (icol == COLS)
                {
                    icol = 0;
                    irow++;
                }
            }
            bInit = true;

            // Timer
            t = new Timer();
            t.Interval = 1000 / 30;
            t.Tick += new EventHandler(t_Tick);
            t.Enabled = true;
        }

        public void InitBoard(){
            int i = 0;
            int irow = 0;
            int icol = 0;
            g = new GameBoard();
            g.Position.X = GAME_OFFSET_X;
            g.Position.Y = GAME_OFFSET_Y;
            g.Width = this.ClientRectangle.Width - (2 * GAME_OFFSET_X);
            g.Height = this.ClientRectangle.Height - (2 * GAME_OFFSET_Y);

            p.Width = PLAYER_WIDTH;
            p.Height = PLAYER_HEIGHT;
            p.Position.X = (this.ClientRectangle.Width / 2) - (PLAYER_WIDTH / 2);
            p.Position.Y = this.ClientRectangle.Height - (p.Height + GAME_OFFSET_Y);
            Invader.invaderclass invclass = Invader.invaderclass.class1;
            invaders = new List<Invader>();
            for (i = 0; i < ENEMY_COUNT; i++)
            {
                Vector v = new Vector(1, 0);
                switch (irow)
                {
                    case 0:
                        invclass = Invader.invaderclass.class4;
                        break;
                    case 1:
                        invclass = Invader.invaderclass.class3;
                        break;
                    case 2:
                        invclass = Invader.invaderclass.class2;
                        break;
                    case 3:
                        invclass = Invader.invaderclass.class1;
                        break;
                }
                Invader tmp = new Invader(v, invclass);
                tmp.Position.X = GAME_OFFSET_X + (ENEMY_WIDTH / 2) + (icol * (ENEMY_OFFSET + 32));
                tmp.Position.Y = GAME_OFFSET_Y + (irow * (ENEMY_OFFSET + 32));
                tmp.Width = 32;
                tmp.Height = 32;
                invaders.Add(tmp);
                icol++;
                if (icol == COLS)
                {
                    icol = 0;
                    irow++;
                }
            }
            bInit = true;

            // Timer
            t = new Timer();
            t.Interval = 1000 / 30;
            t.Tick += new EventHandler(t_Tick);
            t.Enabled = true;
        }

        public void GameOver()
        {
            t.Enabled = false;
            
        }
        void t_Tick(object sender, EventArgs e)
        {
            int i = 0 ;
            p.Update(MoveState);
            if (p.Collision(this,this.ClientRectangle.Width,this.ClientRectangle.Height ))
            {
                if (p.Position.X + ( PLAYER_WIDTH / 2 )> this.ClientRectangle.Width / 2){
                    p.Position.X = this.ClientRectangle.Width - GAME_OFFSET_Y - PLAYER_WIDTH / 2;
                }else{
                    p.Position.X = GAME_OFFSET_Y + PLAYER_WIDTH / 2 ;
                }
            }
            sb.Update();
            if (pm != null)
            {
                pm.Update();
                Invader tmp = pm.Collision(this,invaders);
                if (tmp != null)
                {
                    switch (tmp.thisClass)
                    {
                        case Invader.invaderclass.class1:
                            sb.Score += 10;
                            break;
                        case Invader.invaderclass.class2:
                            sb.Score += 15;
                            break;
                        case Invader.invaderclass.class3:
                            sb.Score += 20;
                            break;
                        case Invader.invaderclass.class4:
                            sb.Score += 25;
                            break;
                    }
                    pm = null;
                }
                else
                {
                    if (pm.Position.Y < GAME_OFFSET_Y)
                    {
                        pm = null;
                    }
                }
            }
            bool hadCollision = false;
            int destroyed = 0;
            for ( i = 0 ; i < ENEMY_COUNT; i++){
                invaders[i].Update();
                if (!invaders[i].Destroyed())
                {
                    if (invaders[i].Collision(this, this.ClientRectangle.Width, this.ClientRectangle.Height))
                    {
                        hadCollision = true;
                    }
                }
                else
                {
                    destroyed++;
                }
            }
            if (destroyed == invaders.Count)
            {
                // level over
                InitBoard();
                t.Enabled = false;
            }
            if (hadCollision){
                for (i = 0; i < ENEMY_COUNT; i++){

                    invaders[i].v.x *= -1.20;
                    if (invaders[i].v.x > 10)
                    {
                        invaders[i].v.x = 10;
                    }
                    if (invaders[i].v.x < -10)
                    {
                        invaders[i].v.x = -10;
                    }
                    invaders[i].Position.Y += 16;
                }
                
            }
            this.Invalidate(false);
            this.Update();
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            int i = 0 ;
            if (bInit)
            {
                e.Graphics.Clear(Color.Black);
                g.Draw(e.Graphics);
                p.Draw(this,e.Graphics);
                sb.Draw(e.Graphics);
                if (pm != null)
                {
                    pm.Draw(e.Graphics);
                }
                for (i = 0; i < ENEMY_COUNT; i++){
                    if (!invaders[i].Destroyed()){
                        invaders[i].Draw(this,e.Graphics);
                    }
                }
            }else{
                e.Graphics.FillRectangle(Brushes.Black, 0,0, this.Width, this.Height);
            }
        }

        protected override void WndProc(ref Message m)
        {
            switch (m.Msg)
            {
                case WM_PAINT :
                    System.Diagnostics.Debugger.Log(0, "", "WM Paint");
                    base.WndProc(ref m);
                    break;
                case WM_ERASEBKGND:
                    System.Diagnostics.Debugger.Log(0, "", "WM Erase Bkgnd");
                    base.WndProc(ref m);
                    break;
                default:
                    base.WndProc(ref m);
                    break;
            }
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            switch (e.KeyCode)
            {
                case Keys.Left:
                    MoveState = movestate.left;
                    break;
                case Keys.Right:
                    MoveState = movestate.right;
                    break;
                case Keys.Space :
                    if (pm == null)
                    {
                        pm = new PlayerMissle();
                        pm.Position.X = p.Position.X;
                        pm.Position.Y = p.Position.Y;
                        pm.Width = 3;
                        pm.Height = 3;
                    }
                    break;
            }
        }

        private void Form1_KeyUp(object sender, KeyEventArgs e)
        {
            switch (e.KeyCode)
            {
                case Keys.Left:
                    if (MoveState == movestate.left)
                    {
                        MoveState = movestate.none;
                    }
                    break;
                case Keys.Right:
                    if (MoveState == movestate.right)
                    {
                        MoveState = movestate.none;
                    }
                    break;
                case Keys.Space:

                    break;
            }
        }
    }
}
